import es
import popuplib
import playerlib
import usermsg
import votelib
import cmdlib
import gamethread
from clans import clans as clan
punishment = {}

def load():
    if votelib.exists('clanadmin_vote'):
        votelib.delete('clanadmin_vote')
    cmdlib.unregisterClientCommand('punreason')
    cmdlib.registerClientCommand('punreason', reason, 'Reason for punishment vote')
    clan.registerextension('clanmanageradminvote', 'Admin Vote!')
    clanmanageradminvote = popuplib.create('clanmanageradminvote')
    clanmanageradminvote.addline("Admin Vote!") 
    clanmanageradminvote.addline('-------------')
    clanmanageradminvote.addline(' ')
    clanmanageradminvote.addline('->1. Kick')
    clanmanageradminvote.addline('->2. Ban')
    clanmanageradminvote.addline('->3. Slay')
    clanmanageradminvote.addline('->4. Mute')
    clanmanageradminvote.addline(' ')
    clanmanageradminvote.addline('-------------')
    clanmanageradminvote.addline('->8. Back') 
    clanmanageradminvote.addline('0. Cancel') 
    clanmanageradminvote.menuselect = clanmanageradminvote_menuselect

def unload():
    cmdlib.unregisterClientCommand('punreason')
 
def clanmanageradminvote_menuselect(userid, choice, popupid):
    if clan.ismember(userid):
        steam = es.getplayersteamid(userid)
        name = es.getplayername(userid)
        if votelib.isrunning('clanadmin_vote'):
            es.tell(userid, "#multi", "#lightgreen[#greenClan Admin Vote#lightgreen] #defaultA Vote Is All Ready in Progress!")
            return
            return
        elif choice == 1:
            punishment[steam] = {}
            punishment[steam]['punishment'] = 'Kick'
            userlist(userid, steam)
        elif choice == 2:
            punishment[steam] = {}
            punishment[steam]['punishment'] = 'Ban'
            userlist(userid, steam)
        elif choice == 3:
            punishment[steam] = {}
            punishment[steam]['punishment'] = 'Slay'
            userlist(userid, steam)
        elif choice == 4:
            punishment[steam] = {}
            punishment[steam]['punishment'] = 'Mute'
            userlist(userid, steam)
    if choice == 8:
        clan.sendextensionmenu(userid)
        #popuplib.send('clanmenu', userid)

def userlist(userid, steam):
    userlist = popuplib.easymenu('userlist', '_popup_choice', userlistmenu) 
    userlist.settitle("Select a user to ")   
    for user in es.getUseridList():
        name = es.getplayername(user)
        userlist.addoption(name, name) 
    userlist.menuselect = userlistback
    userlist.send(userid)

def userlistmenu(userid, choice, menuname):
    steam = es.getplayersteamid(userid)
    punishment[steam]['person'] = es.getuserid(choice)
    es.escinputbox(30, userid, "Reason for %s?" % punishment[steam]['punishment'], "Reason?", "punreason")


def userlistback(caller, select, menuname):
    if select == 10:
        popuplib.send('clanmanageradminvote', caller)

def reason(userid, args):
    steam = es.getplayersteamid(userid)
    if votelib.isrunning('clanadmin_vote'):
        es.tell(userid, "#multi", "#lightgreen[#greenClan Admin Vote#lightgreen] #defaultA Vote Is All Ready in Progress!")
        return
    punishment[steam]['reason'] = str(args)
    votestart(steam)

def votestart(steam):
    global freekill, freekiller
    if votelib.isrunning('clanadmin_vote'):
        es.tell(steam, "#multi", "#lightgreen[#greenClan Admin Vote#lightgreen] #defaultA Vote Is All Ready in Progress!")
        return
    if votelib.exists('clanadmin_vote'):
        votelib.delete('clanadmin_vote')
    clanadmin = votelib.create('clanadmin_vote', vote_end, vote_submit)
    # Set question and add some options
    clanadmin.setquestion('Should %s be %s' % (es.getplayername(punishment[steam]['person']), punishment[steam]['punishment']))
    clanadmin.addoption('Yes') 
    clanadmin.addoption('No')
    onlinemembers = []
    for user in es.getUseridList():
        if clan.ismember(user):
            es.tell(user, "#multi", '#lightgreen[#greenClan Admin Vote#lightgreen] #default%s started vote to %s %s' % (es.getplayername(es.getuserid(steam)),punishment[steam]['punishment'],es.getplayername(punishment[steam]['person'])))
            es.tell(user, "#multi", '#lightgreen[#greenClan Admin Vote#lightgreen] #defaultREASON: %s' % punishment[steam]['reason'])
            onlinemembers.append(user)
    clanadmin.start(10, onlinemembers)
    gamethread.delayed(11, stop, ())

def stop():
    if votelib.exists('clanadmin_vote'):
        votelib.delete('clanadmin_vote')

def vote_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
    global punishment
    if winname == 'Yes' and winpercent > 66:
        for user in es.getUseridList():
            if clan.ismember(user):
                es.tell(user, "#multi", '#lightgreen[#greenClan Admin Vote#lightgreen] #default%s Percent#lightgreen Of The People Voted #green%s. #lightgreenPunishment Will Now Be Enforced!' % (winpercent, winname))
        for steamid in punishment:
            if 'person' in punishment[steamid] and 'reason' in punishment[steamid] and 'punishment' in punishment[steamid]:
                target =  punishment[steamid]['person']
                logs = open(es.getAddonPath('clans/extensions/adminvote')+'/logs.txt', 'a')
                logs.write("%s\t%s\t%s\t\t%s\t%s\n" % (es.getplayersteamid(target), es.getplayername(target), punishment[steamid]['punishment'], es.getplayername(es.getuserid(steamid)), punishment[steamid]['reason']))
                if punishment[steamid]['punishment'] == 'Kick':
                    es.server.queuecmd('ma_kick %s' % target)
                if punishment[steamid]['punishment'] == 'Ban':
                    es.server.queuecmd('ma_ban %s 20' % target)
                if punishment[steamid]['punishment'] == 'Slay':
                    es.server.queuecmd('ma_slay %s' % target)
                if punishment[steamid]['punishment'] == 'Mute':
                    es.server.queuecmd('ma_mute %s' % target)
            punishment = {}
    elif winname == 'No' and winpercent > 66:
        for user in es.getUseridList():
            if clan.ismember(user):
                es.tell(user, "#multi", '#lightgreen[#greenClan Admin Vote#lightgreen] #defaultVotes were not high enough, no actions will take place!')
        punishment = {}
    if votelib.exists('clanadmin_vote'):
        votelib.delete('clanadmin_vote')

def vote_submit(userid, votename, votesnumber, select):
    for user in es.getUseridList():
        if clan.ismember(user):
            es.tell(user, "#multi", "#lightgreen[#greenClan Admin Vote#lightgreen] #default%s #lightgreenVoted #green%s" % (es.getplayername(userid),select))
