import es
import gamethread 
import path 
from clans import clans as clan

timebetweenadverts = 250 #In seconds

#dont touch this unless you know what your doing
advertList = []

def load():
    filePath = es.getAddonPath('clans/extensions/clanadverts') + "/advertlist.txt" 
    if path.path(filePath).isfile(): 
        f = open(filePath) 
        for x in filter(lambda x: not x.startswith("//"), f.readlines()): 
            advertList.append(x) 
        f.close() 
        displayAdverts() 
    else: 
        f = open(filePath, "w") 
        f.write("// Place your adverts in this file, line by line\n// Any lines starting with \"//\" will be ignored") 
        f.close() 

def unload():
    gamethread.cancelDelayed("displayAdverts") 

def displayAdverts():
    advert = advertList.pop(0) 
    for user in es.getUseridList():
        if clan.ismember(user):
            es.tell(user, "#multi", "#green"+advert)
    advertList.append(advert)
    gamethread.delayedname(timebetweenadverts, "displayAdverts", displayAdverts)